/*--------------------------------------------------------------------------
 * KNAPSACK PROBLEM SOLVER: BRANCH-AND-BOUND WITH K-BEST SOLUTIONS
 * Developed at 'LOT: Laboratorio de Otimizacao' by Aline Leao
 * ICMC/University of Sao Paulo
 * http://www.otm.icmc.usp.br
 *--------------------------------------------------------------------------*/

#ifndef MYLIB_knapsackBBk
#define MYLIB_knapsackBBk

/* Bring in the standard C library files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

typedef struct
{
    double utilidade; 
    double l;
    int demanda;
    int pos;
}
knapsackBBk_Tdata;

int indice(int num_comp_livres, int *x);
int solucao_repetida(int nc, int n, int *x, int **X_nc);
void heapsort(int m, knapsackBBk_Tdata *dados);
void passo2(int c, int n, int nc, knapsackBBk_Tdata *dados, int *x, int **X_nc, double *g_nc, double *lim_inff );
void passo3(int n, int nc, knapsackBBk_Tdata *dados, int *x, double *lim_inff, int **X_nc, double *g_nc);
void passo4(int n, int c,knapsackBBk_Tdata *dados, int *x, double *lim_sup, int *controla, int *controlb, int *k);
void passo5(int c, int n, knapsackBBk_Tdata *dados, int *controla, int *controlb, double *lim_sup, double *lim_inff, int *x, int *k, int nc, int **X_nc, double *g_nc);
void branch_bound_k(knapsackBBk_Tdata *dados, int n, int c, int *ns_aux, int ***X, double **g_nsaux);

#endif

