#ifndef   UNDERSCORE
#define        SPCMPS         spcmps_
#define        RDMPS1         rdmps1_
#define        REDUCE         reduce_
#define        LHOPDM         lhopdm_
#define        RELOAD         reload_
#define        LOADQP         loadqp_
#define        MKCOPY         mkcopy_
#define        RMNONZ         rmnonz_
#define        PREPRO         prepro_
#define        QPREPR         qprepr_
#define        PREPMF         prepmf_
#define        WRTSOL         wrtsol_
#define        WRTPSL         wrtpsl_
#define        SOLVER         solver_
#define        GETAC          getac_
#define        WARMST         warmst_
#else
#define        SPCMPS         spcmps
#define        RDMPS1         rdmps1
#define        REDUCE         reduce
#define        LHOPDM         lhopdm
#define        RELOAD         reload
#define        LOADQP         loadqp
#define        MKCOPY         mkcopy
#define        RMNONZ         rmnonz
#define        PREPRO         prepro
#define        QPREPR         qprepr
#define        PREPMF         prepmf
#define        WRTSOL         wrtsol
#define        WRTPSL         wrtpsl
#define        SOLVER         solver
#define        GETAC          getac
#define        WARMST         warmst
#endif



extern  
void    SPCMPS(long *ientry, long *iolog, char* file_spc, 
        long *maxm, long *maxn, long *maxnza, long *irobj, 
        long *level_presolve, double *opt_tol, double *mult, double *big, 
        char *rwname, char *clname, INTS *stavar, INTS *rwstat, 
        INTS *row_numbers, INTS *hd_rw_cds, INTS *link_rw_cds, 
        INTS *hd_cl_cds, INTS *link_cl_cds, long *col_pointers, 
        long *irow, double *a_coeffs, double *rhs, double *ranges, 
        double *upbnd, double *lobnd, double *relt);

extern  
void    RDMPS1(long *rcode, long *lpqp, long *maxm, long *maxn, 
        long *maxnza, long *maxnzq,
        long *m, long *n, long *nza, long *nzq, long *irobj, long *iolog,
        double *big, double *dlobnd, double *dupbnd, double *objcon,
        char *namec, char *nameb, char *namran, char *nambnd, 
        char *nammps, char *filmps,
        double *qdiag, long *qclpts, INTS *qrwnbs, double *qcoeff, 
        char *rwname, char *clname, INTS *stavar, INTS *rwstat, 
        INTS *hd_rw_cds, INTS *link_rw_cds, INTS *hd_cl_cds, INTS *link_cl_cds, 
        INTS *row_numbers, long *col_pointers, long *irow,
        double *a_coeffs, double *rhs, double *ranges, 
        double *upbnd, double *lobnd, double *relt); 

extern  
void    REDUCE(long *icall, long *tcode, long *maxm, long *maxn, long *maxnza, 
        long *m, long *n, long *isoln, long *msglev, long *levprs, long *irobj, long *iolog, 
        long *lnhist, long *mxhist, long *inhsti, long *inhstj, double *dphist,
        long *irow, double *relt, long *intmp1, INTS *intmp2, 
        INTS *intmp3, INTS *isinqp, long *imtmp1, long *imtmp2, 
        double *rmtmp1, double *rntmp1, double *rntmp2,
        INTS *perm, INTS *invp, INTS *header, INTS *linkfd, INTS *linkbk,
        INTS *stavar, INTS *jsign, INTS *starow, INTS *rwstat, 
        char *rwname, char *clname, 
        double *mult, double *ranges, double *b, double *c,
        double *upbnd, double *lobnd, double *p, double *q, double *bnew,
        double *acoeff, long *clpnts, INTS *rwnmbs, 
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol, 
        long *mcopy, long *ncopy, 
        char *rwcopy, INTS *cstvar, INTS *cstrow, INTS *crwst, 
        double *bcopy, double *ccopy, double *lobndc, double *upbndc, 
        double *acffcp, long *clptcp, INTS *rwnbcp, INTS *lnclcp);

extern  
void    LHOPDM(double *c, double *b, double *ranges,
        long *clpnts, INTS *rwnmbs, double *acoeff,
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol,
        long *mm, long *mn, long *mnza, long *m, long *n, long *nza, long *n_str,
        INTS *perm, INTS *invp, long *imtmp1, long *imtmp2, double *rmtmp1,
        INTS *stavar, double *upbnd, double *lobnd, double *big, 
        char *rwname, INTS *rwstat, INTS *starow, char *clname,
        INTS *cstvar, INTS *cstrow, double *p, double *q, 
        long *irow, double *relt, double *x, long *mfact, long *freevr, long *iolog);

extern  
void    RELOAD(long *maxm, long *maxn, long *maxnza, long *m, long *n,
        long *clpnts, INTS *rwnmbs, double *acoeff,
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol,
        INTS *stavar, double *relt, double *acopy, long *iolog);

extern  
void    LOADQP(long *tcode, long *maxm, long *maxn, long *maxl,
        long *maxnzq, long *maxnzl, long *m, long *n, 
        long *ninmps, long *n_str, long *freevr, INTS *stavar, 
        double *qcoeff, long *qclpts, INTS *qrwnbs, double *qdiag,
        double *lcoeff, long *lclpts, INTS *lrwnbs, double *ldiag, long *llinks,
        long *header, long *lenrow, long *irow, double *relt, long *iolog);

extern  
void    MKCOPY(long *maxm, long *maxn, long *maxnza,
        long *m, long *n, INTS *stavar, long *iolog, 
        double *acoeff, long *clpnts, INTS *rwnmbs, 
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol, 
        double *a2cff, long *cl2pts, INTS *rw2nbs, 
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col);

extern  
void    RMNONZ(long *maxm, long *maxn, long *maxl,
        long *maxnza, long *maxnzl, long *m, long *n, 
        long *n_str, long *iolog, 
        double *a2cff, long *cl2pts, INTS *rw2nbs, 
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col,
        INTS *isinqp, long *lclpts, INTS *lrwnbs, long *llinks,
        INTS *stavar, INTS *stavr2, long *irow, double *relt, 
        long *iltmp1, long *iltmp2, long *iltmp3, 
        long *marker, INTS *mhead, INTS *linkfd, INTS *linkbk);

extern  
void    PREPRO(long *maxm, long *maxn, long *maxnza,
        long *maxnzl, long *m, long *n, 
        double *acoeff, double *b, long *irow, double *relt,
        long *clpnts, INTS *rwnmbs, long *rwhead, long *rwlink, 
        INTS *clnmbs, INTS *lencol, 
        double *a2cff, long *cl2pts, INTS *rw2nbs, 
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col, 
        long *intmp1, long *imtmp1, long *imtmp2, double *rmtmp1,
        long *dhead, long *perm0, long *invp0, 
        long *nbrhd, long *qsize, long *qlink,
        INTS *perm, INTS *invp, INTS *header, INTS *linkfd, INTS *linkbk,
        long *lclpts, INTS *lrwnbs, long *llinks,
        INTS *stavar, long *vused, long *vbnded,
        double *p, double *q, char *rwname, INTS *starow, INTS *rwstat,
        double *ranges, long *nzl, long *iwindw, long *icall, INTS *isllt,
        long *iqp, long *kptype, long *iolog);

extern  
void    QPREPR(long *maxm, long *maxn, long *maxnza, long *maxl,
        long *maxnzl, long *maxnzq, long *m, long *n,
        double *acoeff, double *b, long *irow, double *relt,
        long *clpnts, INTS *rwnmbs, long *rwhead, long *rwlink,
        INTS *clnmbs, INTS *lencol,
        double *a2cff, long *cl2pts, INTS *rw2nbs,
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col,
        long *iltmp1, long *iltmp2, long *iltmp3, double *rltmp1,
        long *dhead, long *perm0, long *invp0,
        long *nbrhd, long *qsize, long *qlink,
        INTS *qperm, INTS *qinvp, INTS *pvtype,
        INTS *header, INTS *linkfd, INTS *linkbk,
        long *qclpts, INTS *qrwnbs,
        long *lclpts, INTS *lrwnbs, long *llinks,
        INTS *stavar, long *vused, long *vbnded,
        double *p, double *q, char *rwname, INTS *starow, INTS *rwstat,
        double *ranges, long *nzl, long *iwindw, long *icall,
        long *iqp, long *kptype, long *iolog);

extern  
void    PREPMF(long *maxm, long *maxn, long *maxnza,
        long *m, long *n, long *idnspb,
        long *clpnts, INTS *rwnmbs, long *rwhead, long *rwlink,
        INTS *clnmbs, INTS *lencol,
        INTS *perm, INTS *invp, long *lclpts, long *imtmp1, long *imtmp2,
        INTS *stavar, long *vused, long *vbnded,
        long *nzl, long *iwindw, long *iqp, long *kptype, long *iolog);

extern  
void    WRTSOL(char *filsol, char *nammps, 
        long *max_m, long *max_n, long *max_nza, long *m, long *n, 
        long *mcopy, long *ncopy, long *iolog, long *iwrite, 
        long *irobj, double *mult, INTS *crwst, char *rwcopy, char *clname, 
        long *lpqp, double *objcon, double *qpobj, 
        double *lobndc, double *upbndc, double *bcopy, double *ccopy, 
        double *xorgnl, double *yorgnl, double *prlact, double *dlact, 
        long *imtmp1);

extern  
void    WRTPSL(char *filsol, char *nammps, 
        long *max_m, long *max_n, long *max_nza, long *m, long *n, 
        long *mcopy, long *ncopy, long *iolog, long *iwrite, 
        long *irobj, double *mult, char *clname, 
        long *lpqp, double *objcon, double *qpobj, 
        double *xorgnl, double *yorgnl);

extern  
void    SOLVER(long *maxnzl, long *nzl, long *maxnzq, long *nzq,
        long *maxnza, long *nza, long *maxm, long *m, long *m0, long *mfinal,
        long *maxn, long *n, long *nstrct, long *maxl, long *lmax, long *lauxwk,
        long *matrixFree, long *lrankZero, long *idnspb, long *idnsch, long *max_chl,
        long *isoln, long *tcode, long *iter, long *iwindw, long *iolog, long *msglev,
        long *lpqp, long *mfact, long *iqp, long *itslv, long *kptype, long *icnvx,
        long *scaleRows, long *scaleCols, long *scaleObj, long *scaleRhs,
        double *opttol, long *irobj, double *qpobj, long *freevr, double *mult,
        double *acoeff, double *c, double *b, long* clpnts, INTS *rwnmbs,
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol,
        double *a2cff, long *cl2pts, INTS *rw2nbs,
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col, INTS *isllt,
        long *irow, double *relt, double *auxwrk,
        long *lnhist, long *mxhist, long *inhsti, long *inhstj, double *dphist,
        INTS *rwperm, INTS *rwinvp, INTS *perm, INTS *invp, INTS *pvtype,
        INTS *header, INTS *linkfd, INTS *linkbk,
        long *iltmp1, long *iltmp2, long *iltmp3, INTS *intmp2, INTS *intmp3,
        long *qclpts, INTS *qrwnbs, double *qcoeff, double *qdiag,
        long *lclpts, INTS *lrwnbs, double *lcoeff, double *ldiag,
        long *llinks, double *ldsqrt,
        INTS *stavar, INTS *jsign, INTS *starow, INTS *rwstat,
        char *rwname, char *clname, long *vused, long *vbnded,
        double *lobnd, double *upbnd, double *ranges,
        double *x, double *s, double *y, double *z, double *w,
        double *xprox, double *yprox,
        double *delx, double *dels, double *dely, double *delz, double *delw,
        double *rscale, double *cscale, double *theta, double *pdReg,
        double *objlqp, double *xib, double *xic, double *xiu,
        double *chol, double *diagch, long *lclpch, INTS *lrowch,
        long *lrwhd, long *lrwlnk, INTS *lcolch,
        double *rhspcg, double *solpcg, double *dirpcg, double *respcg,
        double *prcndr, double *tmpM, double *tmpN, 
        long *list, long *marker, long *intwrk, long *itmxcg, double *tolpcg,
        double *rmtmp1, double *rmtmp2, double *rmtmp3, double *rmtmp4, double *rmtmp5,
        double *rntmp1, double *rntmp2, double *rntmp3, double *rntmp4, double *rntmp5,
        double *rntmp6, double *colnrm, double *p, double *q,
        long *mcopy, long *ncopy, char *rwcopy,
        INTS *cstvar, INTS *cstrow, INTS *crwst,
        double *bcopy, double *ccopy, double *lobndc, double *upbndc,
        double *acffcp, long *clptcp, INTS *rwnbcp, INTS *lnclcp,
        long *iexit, double *errorb, double *erroru, double *errorc,
        double *asmall, double *alarge,
        long *istart, long *m_save, long *n_save, long *n_str_save,
        char *rwsave, double *xsave, double *ssave,
        double *ysave, double *zsave, double *wsave, double *bsave
        );

extern  
void    GETAC(long *maxnzl, long *nzl, long *maxnzq, long *nzq, 
        long *maxnza, long *nza, long *maxm, long *m, long *m0, long *mfinal, 
        long *maxn, long *n, long *nstrct, long *maxl, long *lmax, long *lauxwk, 
        long *isoln, long *tcode, long *iter, long *iwindw, long *iolog, long *msglev, 
        long *lpqp, long *mfact, long *iqp, long *itslv, long *kptype, long *icnvx,
        long *scaleRows, long *scaleCols, long *scaleObj, long *scaleRhs,
        double *opttol, long *irobj, double *qpobj, long *freevr, double *mult, 
        double *acoeff, double *c, double *b, long* clpnts, INTS *rwnmbs, 
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol, 
        double *a2cff, long *cl2pts, INTS *rw2nbs, 
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col, INTS *isllt,
        long *irow, double *relt, double *auxwrk, 
        long *lnhist, long *mxhist, long *inhsti, long *inhstj, double *dphist, 
        INTS *rwperm, INTS *rwinvp, INTS *perm, INTS *invp, INTS *pvtype, 
        INTS *header, INTS *linkfd, INTS *linkbk,
        long *iltmp1, long *iltmp2, long *iltmp3, INTS *intmp2, INTS *intmp3, 
        long *qclpts, INTS *qrwnbs, double *qcoeff, double *qdiag, 
        long *lclpts, INTS *lrwnbs, double *lcoeff, double *ldiag, 
        long *llinks, double *ldsqrt,
        INTS *stavar, INTS *jsign, INTS *starow, INTS *rwstat, 
        char *rwname, char *clname, long *vused, long *vbnded,
        double *lobnd, double *upbnd, double *ranges, 
        double *x, double *s, double *y, double *z, double *w, 
        double *xprox, double *yprox,
        double *delx, double *dels, double *dely, double *delz, double *delw, 
        double *rscale, double *cscale, double *theta, double *pdReg, 
        double *objlqp, double *xib, double *xic, double *xiu,
        double *rmtmp1, double *rmtmp2, double *rmtmp3, double *rmtmp4, double *rmtmp5, 
        double *rntmp1, double *rntmp2, double *rntmp3, double *rntmp4, double *rntmp5, 
        double *rntmp6, double *colnrm, double *p, double *q, 
        long *mcopy, long *ncopy, char *rwcopy, 
        INTS *cstvar, INTS *cstrow, INTS *crwst, 
        double *bcopy, double *ccopy, double *lobndc, double *upbndc, 
        double *acffcp, long *clptcp, INTS *rwnbcp, INTS *lnclcp, 
        long *iexit, double *errorb, double *erroru, double *errorc,
        double *asmall, double *alarge,
        long *istart, long *m_save, long *n_save, long *n_str_save,
        char *rwsave, double *xsave, double *ssave, 
        double *ysave, double *zsave, double *wsave, double *bsave
        );

extern  
void    WARMST(long *maxnzl, long *nzl, long *maxnzq, long *nzq, 
        long *maxnza, long *nza, long *maxm, long *m, long *m0, long *mfinal, 
        long *maxn, long *n, long *nstrct, long *maxl, long *lmax, long *lauxwk, 
        long *isoln, long *tcode, long *iter, long *iwindw, long *iolog, long *msglev, 
        long *lpqp, long *mfact, long *iqp, long *itslv, long *kptype, long *icnvx,
        long *scaleRows, long *scaleCols, long *scaleObj, long *scaleRhs,
        double *opttol, long *irobj, double *qpobj, long *freevr, double *mult, 
        double *acoeff, double *c, double *b, long* clpnts, INTS *rwnmbs, 
        long *rwhead, long *rwlink, INTS *clnmbs, INTS *lencol, 
        double *a2cff, long *cl2pts, INTS *rw2nbs, 
        long *rw2hd, long *rw2lnk, INTS *cl2nbs, INTS *ln2col, INTS *isllt,
        long *irow, double *relt, double *auxwrk, 
        long *lnhist, long *mxhist, long *inhsti, long *inhstj, double *dphist, 
        INTS *rwperm, INTS *rwinvp, INTS *perm, INTS *invp, INTS *pvtype, 
        INTS *header, INTS *linkfd, INTS *linkbk,
        long *iltmp1, long *iltmp2, long *iltmp3, INTS *intmp2, INTS *intmp3, 
        long *qclpts, INTS *qrwnbs, double *qcoeff, double *qdiag, 
        long *lclpts, INTS *lrwnbs, double *lcoeff, double *ldiag, 
        long *llinks, double *ldsqrt,
        INTS *stavar, INTS *jsign, INTS *starow, INTS *rwstat, 
        char *rwname, char *clname, long *vused, long *vbnded,
        double *lobnd, double *upbnd, double *ranges, 
        double *x, double *s, double *y, double *z, double *w, 
        double *xprox, double *yprox,
        double *delx, double *dels, double *dely, double *delz, double *delw, 
        double *rscale, double *cscale, double *theta, double *pdReg, 
        double *objlqp, double *xib, double *xic, double *xiu,
        double *rmtmp1, double *rmtmp2, double *rmtmp3, double *rmtmp4, double *rmtmp5, 
        double *rntmp1, double *rntmp2, double *rntmp3, double *rntmp4, double *rntmp5, 
        double *rntmp6, double *colnrm, double *p, double *q, 
        long *mcopy, long *ncopy, char *rwcopy, 
        INTS *cstvar, INTS *cstrow, INTS *crwst, 
        double *bcopy, double *ccopy, double *lobndc, double *upbndc, 
        double *acffcp, long *clptcp, INTS *rwnbcp, INTS *lnclcp, 
        long *iexit, double *errorb, double *erroru, double *errorc,
        double *asmall, double *alarge,
        long *istart, long *m_save, long *n_save, long *n_str_save,
        char *rwsave, double *xsave, double *ssave, 
        double *ysave, double *zsave, double *wsave, double *bsave
        );
