/*
 *  This is a private memory allocator of HOPDM.
 *  --------------------------------------------
 *
 *  Written by:    Jacek Gondzio
 *                 Department of Mathematics and Statistics,
 *                 The University of Edinburgh,
 *                 Mayfield Road, King's Buildings.
 *                 EH9 3JZ Edinburgh, Scotland.
 *  on leave from: Systems Research Institute, 
 *                 Polish Academy of Sciences,
 *                 Newelska 6, 01-447 Warsaw, Poland.
 *
 *  Last modified: October 3, 1999.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>




void* my_vector (void* x, const char *id, int el_size, unsigned n, 
                 const char *fname, int line_no)
{
   void *pointer = calloc(n, el_size);

   if(x != 0) {
      printf("Possible duplicate allocation called for %s (in %s at line %d).\n", 
        id, fname, line_no);
      exit(1);
   }

   if(pointer == 0) {
      printf("No memory for %d elements of size %d in %s at line %d\n", 
        n, el_size, fname, line_no);
      exit(1);
   } else {
      /*
      printf("Memory allocated for %d elements of size %d (line %d).\n", 
        n, el_size, line_no);
      */
   }
   return pointer;
}

void* my_free (void* x, const char *id, const char *fname, int line_no)
{
   if(x == 0) {
      printf("Duplicate free called for %s in %s at line %d\n", 
        id, fname, line_no);
      exit(1);
   } else {
      free(x);
      x = 0;
   }
   return x;
}
